#! /usr/bin/perl
#Copyright (C) 2002  The PARI group.
#
#This file is part of the GP2C package.
#
#PARI/GP is free software; you can redistribute it and/or modify it under the
#terms of the GNU General Public License as published by the Free Software
#Foundation. It is distributed in the hope that it will be useful, but WITHOUT
#ANY WARRANTY WHATSOEVER.
#
#Check the License for details. You should have received a copy of it, along
#with the package; see the file 'COPYING'. If not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#This is the description compiler for gp2c.

$/="\n;";
while(<>)
{
  #Remove shell-style comments, but only at start of lines.
  s/^#.*//gm;
  #C-style comments are inserted in the code.
  ($gpname,$buf)=split(':',$_,2);
  next if $buf eq "";
  $gpname =~ s/^[ \n\t]*//;
  $gpname =~ s/\([0-9]*\)//;# Section number are not used for now.
  print "Function: $gpname\nDescription:\n";
  chop($buf);chop($buf);
  @rules=split(/\n\|/,$buf);
  foreach (@rules)
  {
    if (/^[ \n\t]*\{/)
    {
      #This is a prototype
      /^[ \n\t]*\{([^}]*)\}
	[ \n\t]*:[ \n\t]*
	([A-Za-z0-9_:]*)
	[ \n\t]*
	([^\n]+?)
	[ \t\n]*$/x or die;
      my $proto=$1;
      $cname=$3;
      $typelist=$2;
      @type=split(':',$typelist);
    }
    else
    {
      /^[ \n\t]*\(([^:]*)\)
	[ \n\t]*:[ \n\t]*
	([A-Za-z0-9_:]*)
	[ \n\t]*
	([^\n]+?)
	[ \t\n]*$/x or die;
      my $arglist=$1;
      my $cname=$3;
      my $typelist=$2;
      $arglist =~ tr/ \n\t//d;
      my @args=split(',',$arglist);
      my @type=split(':',$typelist);
      print " (",join(", ",@args),")",":",join(":",@type),"\t",$cname,"\n";
    }
  }
  print "\n";
}
